unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, JvComponentBase, JvTrayIcon, Menus, JvMenus,
  JvBalloonHint, JvLogFile, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, StdCtrls,IniFiles,ShellAPI, SevenZipVCL, ComCtrls,
  JvCreateProcess, IdMessage, IdMessageClient, IdSMTP;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    JvTrayIcon1: TJvTrayIcon;
    JvPopupMenu1: TJvPopupMenu;
    O1: TMenuItem;
    N1: TMenuItem;
    X1: TMenuItem;
    JvLogFile1: TJvLogFile;
    Button2: TButton;
    SevenZip1: TSevenZip;
    JvCreateProcess1: TJvCreateProcess;
    IdFTP1: TIdFTP;
    IdSMTP1: TIdSMTP;
    IdMessage1: TIdMessage;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure Button2Click(Sender: TObject);
    procedure IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: String);
    procedure JvTrayIcon1DblClick(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    

  private
    { Private declarations }
  public
    { Public declarations }

    function ConnectFTP(putname:string):Boolean ;
    procedure BackupProcess;
    procedure SendMail;
  end;

var
  Form1: TForm1;
  gHour: string;
  gMin: string;
  gSec: string;
  OutBackupPath: string;
  
implementation

{$R *.dfm}

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Present : string;
  Hour,Min,Sec:string;
begin
  Present := Trim(FormatDateTime('hh:mm:ss',Now()));
  //ShowMessage(Present);
  { o  }
  Hour := Trim(Copy(Present,1,2));
  { o  }
  Min  := Trim(Copy(Present,4,2));
  { o  }
  Sec  := Trim(Copy(Present,7,2));
  //JvLogFile1.add(Hour +'|' +min+'|'+sec);

   if ((Hour=gHour) and (Min=gMin) and (Sec=gSec)) then
  begin
    //ShowMessage('ɶ');
    BackupProcess;
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  inifile : TIniFile;
begin
  inifile       := TIniFile.Create('.\dumpfile.ini');
  gHour         := inifile.ReadString('BackupTimer','Hour','');
  gMin          := inifile.ReadString('BackupTimer','Min','');
  gSec          := inifile.ReadString('BackupTimer','Sec','');

  inifile.Free;
  JvLogFile1.Add('}Ҧ۰ʳƥ{AݩR....');
end;

procedure TForm1.X1Click(Sender: TObject);
begin
  Form1.Free;
end;

procedure TForm1.O1Click(Sender: TObject);
begin
  JvTrayIcon1.ShowApplication;
  Form1.show;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   Application.Terminate;
   JvLogFile1.Add('{....');
end;

function TForm1.ConnectFTP(putname:string):Boolean ;
var IniFile : tinifile;
begin
   // Ūftp]w
   IniFile := TIniFile.Create('.\dumpfile.ini');

   IdFTP1.Host     := IniFile.ReadString( 'ServerOptions' , 'FtpServerIP'   , '' );
   IdFTP1.Port     := IniFile.ReadInteger( 'ServerOptions', 'FtpServerPort', 21 );
   IdFTP1.Username := IniFile.ReadString( 'ServerOptions' , 'UserName'      , '' );
   IdFTP1.Password := IniFile.ReadString( 'ServerOptions' , 'UserPassword' , '' );

   IdFTP1.Connect();
   IdFTP1.Put(putname, ExtractFileName(putname));
   IdFTP1.Disconnect;    

   Result:=True;
end;



procedure TForm1.BackupProcess;
var
  IniFile:TIniFile;
  files:TextFile;

  str,str1:string;
  section: TStringList;
  i: Integer;
  tempDate: string;

  dbUser : string;
  dbPass : string;
  dbServerName:string;    
begin
  tempDate := FormatDateTime( 'yyyymmdd', Now() );
  JvLogFile1.Add('iJ procedure BackupProcess....');

  //ŪX]w
  IniFile:=TIniFile.Create('.\dumpfile.ini');
  section:=TStringList.Create;
  IniFile.ReadSection('BackupTables',section);
  dbUser := IniFile.ReadString('DataBaseSet','User','sa');
  dbPass := IniFile.ReadString('DataBaseSet','Pass','');
  dbServerName := IniFile.ReadString('DataBaseSet','ServerName','');

  OutBackupPath := iniFile.ReadString('Option','OutBackupPath','C:\temp');
  OutBackupPath := OutBackupPath  + tempDate + '\';
  ForceDirectories(OutBackupPath);

  //YƮw
  SevenZip1.Files.Clear;
  SevenZip1.SZFileName := OutBackupPath + 'db'+ tempDate + '.7z';
  SevenZip1.VolumeSize := 0; 

  for i :=0 to section.Count -1 do
  begin
    str:=IniFile.ReadString('BackupTables',section[i],'');

    //gJsqlykɮ
    AssignFile(files,'.\History\'+str+tempDate+'.sql');
    Rewrite(files);
    try
       Writeln(files, 'dump database '+str+' to "'+ OutBackupPath+str+tempDate+'.dump"');
       Writeln(files, 'go' );
    finally
      CloseFile(files);
    end;

    //gJ妸ROɮ
    str1 :='isql -U '+dbUser+' -P '+dbPass+' -S '+dbServerName+' -i History\'+str+tempDate+'.sql';

    AssignFile(files,'.\History\'+str+tempDate+'.bat');
    Rewrite(files);
    try
       Writeln(files, str1);
    finally
      CloseFile(files);
    end;

    with JvCreateProcess1 do
    begin
      CommandLine := '.\History\'+str+tempDate+'.bat';
      WaitForTerminate:=True;
      StartupInfo.ShowWindow := swHide;
      StartupInfo.DefaultWindowState := False;
      Run;
      JvLogFile1.Add('ƥƮw:'+str+'}l....');
      while State = psWaiting do begin
        //ݳƥ
        Update;
        Application.ProcessMessages;
      end;
      JvLogFile1.Add('ƥƮw:'+str+'....');
      SevenZip1.Files.AddString(OutBackupPath+str+tempDate+'.dump');
    end;
  end;

  try
    JvLogFile1.Add('}lY{....');
    SevenZip1.Add;
    SevenZip1.Extract;

    if  SevenZip1.LastError = 0  then
    begin
      JvLogFile1.Add('}lW....');
      ConnectFTP(SevenZip1.SZFileName);
    end;

    SendMail;

  finally
    SevenZip1.FreeOnRelease;
    JvLogFile1.Add('} procedure BackupProcess....');
  end;

end; //function

procedure TForm1.Button2Click(Sender: TObject);
begin
BackupProcess;
end;

procedure TForm1.IdFTP1Status(ASender: TObject; const AStatus: TIdStatus;
  const AStatusText: String);
begin
case  AStatus of
    hsResolving    : JvLogFile1.Add('hsResolving');
    hsConnecting   : JvLogFile1.Add('FTPsu....');
    hsConnected    : JvLogFile1.Add('FTPwgsu...');
    hsDisconnecting: JvLogFile1.Add('FTPu....');
    hsDisconnected : JvLogFile1.Add('FTPwgu....');
    hsStatusText   : JvLogFile1.Add('hsStatusText');
    ftpTransfer    : JvLogFile1.Add('ǰeC');
    ftpReady       : JvLogFile1.Add('ǳƶǰe....');
    ftpAborted     : JvLogFile1.Add('ǰe');
  end;
end;

procedure TForm1.JvTrayIcon1DblClick(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  O1Click(nil);
end;

procedure TForm1.SendMail;
var
  tempSection:TStringList;
  tempINI:TIniFile;
  tempStr:string;
  i:integer;
begin
  tempINI:=TIniFile.Create('.\dumpfile.ini');

  with IdSMTP1 do
  begin
    Host:=tempINI.ReadString('ServerOptions','SMTP_HOST','');
    Username:=tempINI.ReadString('ServerOptions','SMTP_USER','');
    Password:=tempINI.ReadString('ServerOptions','SMTP_PASS','');
  end;

  tempSection:=TStringList.Create;
  tempINI.ReadSection('MailList',tempSection);

  for i:=0 to tempSection.Count -1  do
  begin
     tempStr:=tempINI.ReadString('MailList',tempSection[i],'');

     with IdMessage1 do
     begin
        From.Address  := tempINI.ReadString('ServerOptions','SMTP_ADDRESST','');
        Body.Clear;
        Body.Add('AutoBackup v3.5 Ʈwƥt');
        Recipients.EMailAddresses:= tempStr;
        Subject := 'Ʈwƥp^' + DateTimeToStr(Now());
     end;

     //[J
     TIdAttachment.Create(IdMessage1.MessageParts, '.\Log\AutoBackup.log');
     
     if not IdSMTP1.Connected then
     begin
       IdSMTP1.Connect(10000);
       IdSMTP1.Send(IdMessage1);
       IdSMTP1.Disconnect;

     end;
  end;
  
  IdMessage1.Clear;
  tempINI.Free;
end;



end.


